#property copyright "Copyright  2006, Nick Sparrow"   

//Input variable that can be edited by the user when testing
//These varieable are those found under the input tab when looking at the EA's properties

extern string access             = "--------- Registration Access ---------"; //heading
extern string password           = "NnCLLC";//this is set so that everyone can use it at the moment
extern string other_parameters   = "-------- Execution Management --------"; //heading
extern int stoploss              = 15;  //This is your user defined s/l
extern int takeprofit            = 15;  //This is your user defined t/p
extern int barspread             = 8; //How much the bar has to spread apart before a trade will execute
extern int max_trades            = 1;  //Max number of trades that can be executed at any one given time
extern int trailing_stop         = 5; //sets a trailing stop (this won't kick in with such high settings on sl and tp        
extern int ema_period            = 8; //sets the period of the ema
extern string  mm_parameters     = "---------- Money Management ----------";//Just a heading
extern bool money_management     = true; //Use Money Management or not
extern double lots               = 1;  //Number of lots to use.  It will increase lots with increased margin
extern int risk                  = 10; //How much margin to risk 10%. Total risk is determined by your s/l
extern string scalping_control   = "-------- Scalping Control ------------";
extern bool scalp_control        = true; //Use Scalping Control or not.
extern double min_time           = 3;  //Minimum minutes before trade can Close (used becaused Interbank considers trades less than 3min to be scalping and they don't allow scalping on live accounts)
extern double leeway             = 60;  //The temporary ADDITIONAL (on top of sl, tp) min_time leeway. 
extern string color_scheme       = "------------ Color Scheme ------------";
extern color conservative_buy    = CornflowerBlue;
extern color contervative_sell   = Red;
extern color auto_close_buy      = MidnightBlue;
extern color modified_sl_tp_buy  = LightGreen;
extern color auto_close_sell     = Gold;
extern color modified_sl_tp_sell = Violet;

static int time_frame;
int summary = 0;
//A global variable but not one what can be manually changed in under the EA's properties
int ID=983783;         

int orderscnt(){
int cnt=0;
   for(int i =0;i<OrdersTotal();i++){
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
         if(OrderSymbol()==Symbol() && ID==OrderMagicNumber()){
            cnt++;
         }
      }
   }
   return(cnt);
}
int deinit() {
   time_frame = Period();
   return(0);}

//Figure out how many lots to use
int subLotSize()
   {
   int lotMM = MathCeil(AccountFreeMargin() *  risk / 1000) / 100;
	   if(lotMM < 0.1)                  lotMM = lots;
	   if((lotMM > 0.5) && (lotMM < 1)) lotMM = lots;
	   if(lotMM > 1)                    lotMM = MathCeil(lotMM);
	   if(lotMM > 100)                  lotMM = 100;
	return (lotMM);
   }
  
int start()
  {
   if(password == "NnCLLC")
   { 
     double sl,tp,ticket,cnt,scalp_gap,minimum_minutes; //Variable that will be used to store sl and tp data
     int total_orders = OrdersTotal();
     //if (Period() < 30) {Comment("change to M30 or higher pls"); return(0); }      
   
     if(money_management)lots = subLotSize(); //If MM is true then execute the MM function to increase lots with increasing margin
     if(scalp_control)
     {
        minimum_minutes = min_time;
        scalp_gap = leeway;  // Sets the minimum time before a trade can execute
     } 
     //if (MathMod(Minute(),Period()) >= 0.5*Period()) return(0);  I have no idea what this was originally for
   
     //Summary of setup
     if (summary ==0){summary++;
        Print("Hello summary");}
 
     //If bar/candle has moved more than 10 pips in this time frame and if the open is less than the
     //average of the high and the low and at the current moment the ask is less than the open, go long
     if (orderscnt() < max_trades)
     {   
           //double previous_ma1 = iMA(NULL,1,ema_period,0,MODE_EMA,PRICE_CLOSE,1);
           //double current_ma1 = iMA(NULL,1,ema_period,0,MODE_EMA,PRICE_CLOSE,0);
           double previous_ma5 = iMA(NULL,5,ema_period,0,MODE_EMA,PRICE_CLOSE,2);
           double current_ma5 = iMA(NULL,5,ema_period,0,MODE_EMA,PRICE_CLOSE,1);
           double previous_ma15 = iMA(NULL,15,ema_period,0,MODE_EMA,PRICE_CLOSE,2);
           double current_ma15 = iMA(NULL,15,ema_period,0,MODE_EMA,PRICE_CLOSE,1);
           double previous_ma30 = iMA(NULL,30,ema_period,0,MODE_EMA,PRICE_CLOSE,2);
           double current_ma30 = iMA(NULL,30,ema_period,0,MODE_EMA,PRICE_CLOSE,1);
           double previous_ma60 = iMA(NULL,60,ema_period,0,MODE_EMA,PRICE_CLOSE,2);
           double current_ma60 = iMA(NULL,60,ema_period,0,MODE_EMA,PRICE_CLOSE,1);
           //double previous_ma240 = iMA(NULL,240,ema_period,0,MODE_EMA,PRICE_CLOSE,1);
           //double current_ma240 = iMA(NULL,240,ema_period,0,MODE_EMA,PRICE_CLOSE,0);
             
   
             if ((High[0]-Low[0]) > barspread*Point && Open[0]<(High[0]+Low[0])/2 && Ask <= Open[0]&&(current_ma5 > previous_ma5)
                 &&(current_ma15 > previous_ma15)&&(current_ma30 > previous_ma30)&&(current_ma60 > previous_ma60)
                 /*&&(current_ma240 > previous_ma240)*/){
              if(stoploss==0){sl=0;}else{sl=Ask-stoploss*Point-scalp_gap*Point;} 
              if(takeprofit==0){tp=0;}else{tp=Ask+takeprofit*Point+scalp_gap*Point;}
              ticket=OrderSend(Symbol(),OP_BUY,lots,Ask,2,sl,tp,"ConservativeAntClassicBuy",ID,0,conservative_buy);
              Print("Ticket # ",ticket);
             }         
             if ((High[0]-Low[0]) > barspread*Point && Open[0]>(High[0]+Low[0])/2 && Bid >= Open[0]&&(current_ma5 < previous_ma5)
                 &&(current_ma15 < previous_ma15)&&(current_ma30 < previous_ma30)&&(current_ma60 < previous_ma60)
                 /*&&(current_ma240 < previous_ma240)*/){
              if(stoploss==0){sl=0;}else{sl=Bid+stoploss*Point+scalp_gap*Point;}
              if(takeprofit==0){tp=0;}else{tp=Bid-takeprofit*Point-scalp_gap*Point;}
              ticket=OrderSend(Symbol(),OP_SELL,lots,Bid,2,sl,tp,"ConservativeAntClassicSell",ID,0,contervative_sell);
              Print("Ticket # ",ticket); 
             }             
     }//if (total_orders < max_trades)
      
        //Modifying existing orders. 
     for(cnt=0;cnt<total_orders;cnt++)  //This will cycle through each existing order.
     {
        OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);  //Selects the order by index and if it is active.
           if(OrderType()<=OP_SELL && OrderSymbol()==Symbol())  //Checks to insure normal order is for expert's chart.
           {
              //Print(OrderOpenTime(),"OrderOpenTime ",TimeMinute(OrderOpenTime()), "TimeMinute ", CurTime(), "CurTime");
              //Print("Time parameter is true: ",OrderOpenTime(),"  ",(OrderOpenTime()+min_time*60));   
              if(/*SOMEKIND OF TIME PARAMETER*/ CurTime() >= OrderOpenTime()+min_time*60  )   //Time parameter to prevent scalping.
              { //Print("True"); 
               
                 if(OrderType()==OP_BUY)   //Selects buy orders.
                 { 
                       if(stoploss==0){sl=0;}else{sl=OrderOpenPrice()-stoploss*Point;}       
                       if(takeprofit==0){tp=0;}else{tp=OrderOpenPrice()+takeprofit*Point;}
                       if(OrderStopLoss()!= sl)
                       {
                         if(Bid <= sl)
                         {
                            OrderClose(OrderTicket(),OrderLots(),Bid,2,auto_close_buy); //closes the order if after the scalp_gap the price is 
                         }                                                     //outside the tp or sl
                         if(Bid >= tp)
                         {
                         trailing_position_buy(trailing_stop);
                         }
                         else
                         {
                            OrderModify(OrderTicket(),OrderOpenPrice(),sl,tp,0,modified_sl_tp_buy); //modifies the order back to original 
                         }                                                              //parameters
                       }
                 }
                  
                 if(OrderType()==OP_SELL)  //Selects sell orders.
                 {
                       if(stoploss==0){sl=0;}else{sl=OrderOpenPrice()+stoploss*Point;}       
                       if(takeprofit==0){tp=0;}else{tp=OrderOpenPrice()-takeprofit*Point;}
                       if(OrderStopLoss() != sl)
                       {
                         if(Ask >= sl)
                         {
                            OrderClose(OrderTicket(),OrderLots(),Ask,2,auto_close_sell); //closes the order if after the scalp_gap the price is
                         }                                                    //ouside the tp or sl
                         if(Ask <= tp)
                         {
                         trailing_position_sell(trailing_stop);
                         }
                         else
                         {
                            OrderModify(OrderTicket(),OrderOpenPrice(),sl,tp,0,modified_sl_tp_sell); //modifies the order back to original
                         }
                       }                                                                //parameters
                  }
               
              }//if(CurTime() >= OrderOpenTime()+min_time*60)
            
           }//if(OrderType()<=OP_SELL && OrderSymbol()==Symbol())
      }//for(cnt=0;cnt<total_orders;cnt++)
      
    } //if(password == "NnCLLC")
   return(0);
  } // int start()


void trailing_position_buy(int trailingStop) { 
   for (int i=0; i<OrdersTotal(); i++) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol()==Symbol()) { 
            if (OrderType()==OP_BUY) { 
               if (Bid-OrderOpenPrice()>trailingStop*Point) { 
                  if (OrderStopLoss()<Bid-trailingStop*Point) 
                     ModifyStopLossBuy(Bid-trailingStop*Point); 
               } 
            } 
         } 
      } 
   } 
} 
void trailing_position_sell(int trailingStop) { 
   for (int i=0; i<OrdersTotal(); i++) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol()==Symbol()) { 
            if (OrderType()==OP_BUY) { 
               if (OrderOpenPrice()-Ask>trailingStop*Point) { 
                  if (OrderStopLoss()<Ask+trailingStop*Point) 
                     ModifyStopLossSell(Ask+trailingStop*Point); 
               } 
            } 
         } 
      } 
   } 
} 
void ModifyStopLossBuy(double ldStopLoss) { 
   OrderModify(OrderTicket(),Bid,ldStopLoss,OrderTakeProfit(),0,CLR_NONE);  
} 
void ModifyStopLossSell(double ldStopLoss) { 
   OrderModify(OrderTicket(),Ask,ldStopLoss,OrderTakeProfit(),0,CLR_NONE);  
} 